/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.karelia.cs.petrsugen.application;

import java.io.InputStream;

import org.mindswap.pellet.jena.PelletReasonerFactory;


import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.util.FileManager;

//import fi.abo.diem.codegen.framework.SimpleModelImplementator;
import ru.karelia.cs.petrsugen.framework.SimpleModelImplementator;
import ru.karelia.cs.petrsugen.util.Logger;

/**
 *
 * 
 */
public class Generator {
    Logger log;

    public void runGenerator(Logger log, String inputFile, String outputPath, String triplestore, String testProgram, String mainFile, String makeFile, String doxyFile) {
        this.log = log;
        log.info("Code Generator started.");

        //Do stuff
        InputStream in;
        in = FileManager.get().open(inputFile);
        AppConfiguration.init();
        AppConfiguration.setDefaultInputFile(inputFile);
        AppConfiguration.setOutputPath(outputPath);
                
        AppConfiguration.setTripleStore(triplestore);
        AppConfiguration.setTestProgram(testProgram);
        AppConfiguration.setMainFile(mainFile);
        AppConfiguration.setMakeFile(makeFile);
        AppConfiguration.setDoxyFile(doxyFile);
        //OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_DL_MEM);
        // ontology from Jena
        OntModel ontm = ModelFactory.createOntologyModel(PelletReasonerFactory.THE_SPEC);
        ontm.read(in, "");        
        
        // ModelImplementator mi = new ModelImplementator(ontm);
        SimpleModelImplementator mi = new SimpleModelImplementator(ontm, log);
        System.out.println("DONE!");
    }
}
