package ru.karelia.cs.petrsugen.util;

public class TemplateString {
	private String template;
	private String initValue;

	public TemplateString(String template) {
		// this.template = new String(value);
		this.template = template;
		this.initValue = this.template;

	}

	public TemplateString() {
		this.template = "";
	}

	public void resetToInitValue() {
		this.template = this.initValue;
	}

	public void replaceAll(String regex, String replacement) {
		//replacement = replacement.replaceAll("\"", "\\\\\\\\\"");			
		template = template.replaceAll(regex, replacement);	  
				
	}
	/*
	 * This function is for replacing strings with quotations
	 * 
	 */
	public void replaceAll2(String regex, String replacement) {
		replacement = replacement.replaceAll("\"", "\\\\\\\\\"");			
		template = template.replaceAll(regex, replacement);	  
		template = template.replaceAll("\\\\\\\"", "\\\\\\\\\\\\\"");		
	}

	
	public void insertIntoPlaceholder(String tag, String context) {
		template = template.replaceFirst(tag, context + tag);
	}

	public void replaceTag(String tag, String replacement) {
		replacement = replacement.replaceAll("\"", "\\\\\"");
		template = template.replaceAll(tag, replacement);
	}

	public void concat(String s) {
		this.template.concat(s);
	}

	public void removeTags() {

		String regex = "<@[a-zA-Z][^@>]*@>";
		template = template.replaceAll(regex, "");
		regex = "<%[a-zA-Z][^%>]*%>";
		template = template.replaceAll(regex, "");
	}

	public String getString() {
		return template;
	}

}
